/*
package com.ma.demo.commonsUtils.intercept;

import com.alibaba.fastjson.JSON;
import com.ma.demo.commonsUtils.CommonsUtil;
import com.ma.demo.entity.SysOperateLog;
import com.ma.demo.entity.User;
import com.ma.demo.service.SysOperateLogService;
import org.apache.shiro.SecurityUtils;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.lang.reflect.Method;

*/
/**
*
*定义AOP 切面
* *//*

@Aspect
@Component
@SuppressWarnings("rawtypes")
public class SystemLogAspect {

    private static final Logger logger = LoggerFactory.getLogger(SystemLogAspect.class);

    @Autowired
    private SysOperateLogService sysOperateLogService;
    */
/**
     * Service层切点
     *//*

    @Pointcut("@annotation( com.ma.demo.commonsUtils.intercept.SysOperaterLog)")
    public void serviceAspect() {

    }

    */
/**
     * doServiceLog:获取注解参数，记录日志. <br/>
     * @author lcma
     * @param joinPoint 切入点参数
     * @since JDK 1.7
     *//*

    @After("serviceAspect()")
    public  void doServiceLog(JoinPoint joinPoint) {
        logger.info("***************日志记录**************");
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
        //获取管理员用户信息
        //CmsAdmin admin = WebUtils.getAdminInfo(request);
        User user = (User)SecurityUtils.getSubject().getPrincipals().iterator().next();
        try {
            //保存至数据库日志
            SysOperateLog sysOperateLog = new SysOperateLog();
            sysOperateLog.setOperateType(getServiceMthodType(joinPoint));//放法的操作类型
            sysOperateLog.setModuleName(getServiceMthodTableModule(joinPoint));//模块名称
            sysOperateLog.setRemark(getServiceMthodReMark(joinPoint));//获取日志描述信息
            sysOperateLog.setUsername(user.getUsername());
            sysOperateLog.setUserId(String.valueOf(user.getUserId()));
            sysOperateLog.setCreTime(CommonsUtil.getCurrentTime());
            sysOperateLogService.insert(sysOperateLog);//保存至数据库
        }  catch (Exception e) {
            logger.error("异常信息:{}", e);
        }
    }


    */
/**
     * getServiceMthodDescription:获取注解中对方法的描述信息 用于service层注解  . <br/>
     * @author lcma
     * @param joinPoint 切点
     * @return 方法描述
     * @throws Exception
     *//*

    private String getServiceMthodReMark(JoinPoint joinPoint) throws Exception {
        String targetName = joinPoint.getTarget().getClass().getName();
        String methodName = joinPoint.getSignature().getName();
        Object[] arguments = joinPoint.getArgs();
        Class targetClass = Class.forName(targetName);
        Method[] methods = targetClass.getMethods();
        String description = "";
        for(Method method : methods) {
            if(method.getName().equals(methodName)) {
                Class[] clazzs = method.getParameterTypes();
                if(clazzs.length == arguments.length) {
                    description = method.getAnnotation(SysOperaterLog.class).remark();
                    break;
                }
            }
        }
        return description;
    }

    */
/**
     * getServiceMthodTableModule:获取注解中对方法的模块名用于service层注解 . <br/>
     * @author lcma
     * @param joinPoint
     * @return
     * @throws Exception
     *//*

    private String getServiceMthodTableModule(JoinPoint joinPoint) throws Exception {
        String targetName = joinPoint.getTarget().getClass().getName();
        String methodName = joinPoint.getSignature().getName();
        Object[] arguments = joinPoint.getArgs();
        Class targetClass = Class.forName(targetName);
        Method[] methods = targetClass.getMethods();
        String tableType ="";
        for (Method method : methods) {
            if (method.getName().equals(methodName)) {
                Class[] clazzs = method.getParameterTypes();
                if (clazzs.length == arguments.length) {
                    tableType = method.getAnnotation(SysOperaterLog.class).module();
                    break;
                }
            }
        }
        return tableType;
    }


    */
/**
     * getServiceMthodType:获取注解中对方法的操作类型用于service层注解 . <br/>
     * @author lcma
     * @param joinPoint
     * @return
     * @throws Exception
     *//*

    private String getServiceMthodType(JoinPoint joinPoint) throws Exception {
        String targetName = joinPoint.getTarget().getClass().getName();
        String methodName = joinPoint.getSignature().getName();
        Object[] arguments = joinPoint.getArgs();
        Class targetClass = Class.forName(targetName);
        Method[] methods = targetClass.getMethods();
        String operateType ="";
        for (Method method : methods) {
            if (method.getName().equals(methodName)) {
                Class[] clazzs = method.getParameterTypes();
                if (clazzs.length == arguments.length) {
                    operateType = method.getAnnotation(SysOperaterLog.class).operateType();
                    break;
                }
            }
        }
        return operateType;
    }

    */
/**
     * getServiceMthodParams:获取json格式的参数. <br/>
     * @author lcma
     * @param joinPoint
     * @return
     * @throws Exception
     * @since JDK 1.7
     *//*

   private String getServiceMthodParams(JoinPoint joinPoint) throws Exception {
        Object[] arguments = joinPoint.getArgs();
        String params = JSON.toJSONString(arguments);
        return params;
    }
}
*/
