/*
package com.ma.demo.config.shiroConfig;

import com.ma.demo.entity.Menu;
import com.ma.demo.entity.Roles;
import com.ma.demo.entity.User;
import com.ma.demo.service.UserService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.shiro.authc.*;
import org.apache.shiro.authz.AuthorizationInfo;
import org.apache.shiro.authz.SimpleAuthorizationInfo;
import org.apache.shiro.realm.AuthorizingRealm;
import org.apache.shiro.subject.PrincipalCollection;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

public class MyShiroRealm extends AuthorizingRealm {

    private final static Logger log = LoggerFactory.getLogger(MyShiroRealm.class);

    @Autowired
    private UserService userService;

    */
/*
     *身份认证，登录,获取身份验证信息
     * Shiro中，最终是通过 Realm 来获取应用程序中的用户、角色及权限信息的
     *//*

    @Override
    protected AuthenticationInfo doGetAuthenticationInfo(AuthenticationToken token) throws AuthenticationException {
        UsernamePasswordToken utoken = (UsernamePasswordToken) token;//获取用户输入的token

        //String userToken = (String) token.getCredentials();
        log.info("******用户的token" + token.getPrincipal() + "******");
        String username = utoken.getUsername();
        log.info(username);
        User user = userService.selectByUsername(username);
        log.info(user.toString());
        //放入shiro.调用CredentialsMatcher检验密码
        return new SimpleAuthenticationInfo(user, user.getPassword(), this.getClass().getName());
    }

    */
/*
     *授权
     * @param principals 权限信息 身份集合
     * *//*

    @Override
    protected AuthorizationInfo doGetAuthorizationInfo(PrincipalCollection principals) {
        User user = (User) principals.fromRealm(this.getClass().getName()).iterator().next();
        List<String> permissionList = new ArrayList();
        List<String> roleNameList = new ArrayList();
        Set<Roles> roleSet = user.getRoles();
        if (CollectionUtils.isNotEmpty(roleSet)) {
            for (Roles role : roleSet) {
                roleNameList.add(role.getRoleName());
                Set<Menu> menusSet = role.getMenus();
                if (CollectionUtils.isNotEmpty(menusSet)) {
                    for (Menu menu : menusSet) {
                        permissionList.add(menu.getMenuName());
                    }
                }
            }
        }
        SimpleAuthorizationInfo info = new SimpleAuthorizationInfo();
        info.addStringPermissions(permissionList);
        info.addRoles(roleNameList);
        return info;
    }

    */
/**
     * 清除当前用户的权限认证缓存
     *
     * @param principals 权限信息 身份集合
     *//*

    @Override
    public void clearCache(PrincipalCollection principals) {
        super.clearCache(principals);
    }

}
*/
